Linux Audio

Check our new training course

Loading...
v6.2
 1# SPDX-License-Identifier: GPL-2.0
 2#
 3# Kbuild for top-level directory of the kernel
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 4
 5# Prepare global headers and check sanity before descending into sub-directories
 6# ---------------------------------------------------------------------------
 7
 8# Generate bounds.h
 9
10bounds-file := include/generated/bounds.h
11
 
12targets := kernel/bounds.s
13
14$(bounds-file): kernel/bounds.s FORCE
 
 
 
 
 
15	$(call filechk,offsets,__LINUX_BOUNDS_H__)
16
17# Generate timeconst.h
 
18
19timeconst-file := include/generated/timeconst.h
20
21filechk_gentimeconst = echo $(CONFIG_HZ) | bc -q $<
22
23$(timeconst-file): kernel/time/timeconst.bc FORCE
 
 
 
 
 
 
 
 
24	$(call filechk,gentimeconst)
25
26# Generate asm-offsets.h
 
 
27
28offsets-file := include/generated/asm-offsets.h
29
 
30targets += arch/$(SRCARCH)/kernel/asm-offsets.s
31
32arch/$(SRCARCH)/kernel/asm-offsets.s: $(timeconst-file) $(bounds-file)
 
 
 
 
33
34$(offsets-file): arch/$(SRCARCH)/kernel/asm-offsets.s FORCE
35	$(call filechk,offsets,__ASM_OFFSETS_H__)
36
37# Check for missing system calls
 
 
 
 
 
38
39quiet_cmd_syscalls = CALL    $<
40      cmd_syscalls = $(CONFIG_SHELL) $< $(CC) $(c_flags) $(missing_syscalls_flags)
41
42PHONY += missing-syscalls
43missing-syscalls: scripts/checksyscalls.sh $(offsets-file)
44	$(call cmd,syscalls)
45
46# Check the manual modification of atomic headers
47
48quiet_cmd_check_sha1 = CHKSHA1 $<
49      cmd_check_sha1 = \
50	if ! command -v sha1sum >/dev/null; then \
51		echo "warning: cannot check the header due to sha1sum missing"; \
52		exit 0; \
53	fi; \
54	if [ "$$(sed -n '$$s:// ::p' $<)" != \
55	     "$$(sed '$$d' $< | sha1sum | sed 's/ .*//')" ]; then \
56		echo "error: $< has been modified." >&2; \
57		exit 1; \
58	fi; \
59	touch $@
60
61atomic-checks += $(addprefix $(obj)/.checked-, \
62	  atomic-arch-fallback.h \
63	  atomic-instrumented.h \
64	  atomic-long.h)
65
66targets += $(atomic-checks)
67$(atomic-checks): $(obj)/.checked-%: include/linux/atomic/%  FORCE
68	$(call if_changed,check_sha1)
69
70# A phony target that depends on all the preparation targets
71
72PHONY += prepare
73prepare: $(offsets-file) missing-syscalls $(atomic-checks)
74	@:
75
76# Ordinary directory descending
77# ---------------------------------------------------------------------------
78
79obj-y			+= init/
80obj-y			+= usr/
81obj-y			+= arch/$(SRCARCH)/
82obj-y			+= $(ARCH_CORE)
83obj-y			+= kernel/
84obj-y			+= certs/
85obj-y			+= mm/
86obj-y			+= fs/
87obj-y			+= ipc/
88obj-y			+= security/
89obj-y			+= crypto/
90obj-$(CONFIG_BLOCK)	+= block/
91obj-$(CONFIG_IO_URING)	+= io_uring/
92obj-$(CONFIG_RUST)	+= rust/
93obj-y			+= $(ARCH_LIB)
94obj-y			+= drivers/
95obj-y			+= sound/
96obj-$(CONFIG_SAMPLES)	+= samples/
97obj-$(CONFIG_NET)	+= net/
98obj-y			+= virt/
99obj-y			+= $(ARCH_DRIVERS)
v4.6
 
  1#
  2# Kbuild for top-level directory of the kernel
  3# This file takes care of the following:
  4# 1) Generate bounds.h
  5# 2) Generate timeconst.h
  6# 3) Generate asm-offsets.h (may need bounds.h and timeconst.h)
  7# 4) Check for missing system calls
  8
  9# Default sed regexp - multiline due to syntax constraints
 10define sed-y
 11	"/^->/{s:->#\(.*\):/* \1 */:; \
 12	s:^->\([^ ]*\) [\$$#]*\([-0-9]*\) \(.*\):#define \1 \2 /* \3 */:; \
 13	s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; \
 14	s:->::; p;}"
 15endef
 16
 17# Use filechk to avoid rebuilds when a header changes, but the resulting file
 18# does not
 19define filechk_offsets
 20	(set -e; \
 21	 echo "#ifndef $2"; \
 22	 echo "#define $2"; \
 23	 echo "/*"; \
 24	 echo " * DO NOT MODIFY."; \
 25	 echo " *"; \
 26	 echo " * This file was generated by Kbuild"; \
 27	 echo " */"; \
 28	 echo ""; \
 29	 sed -ne $(sed-y); \
 30	 echo ""; \
 31	 echo "#endif" )
 32endef
 33
 34#####
 35# 1) Generate bounds.h
 
 
 36
 37bounds-file := include/generated/bounds.h
 38
 39always  := $(bounds-file)
 40targets := kernel/bounds.s
 41
 42# We use internal kbuild rules to avoid the "is up to date" message from make
 43kernel/bounds.s: kernel/bounds.c FORCE
 44	$(Q)mkdir -p $(dir $@)
 45	$(call if_changed_dep,cc_s_c)
 46
 47$(obj)/$(bounds-file): kernel/bounds.s FORCE
 48	$(call filechk,offsets,__LINUX_BOUNDS_H__)
 49
 50#####
 51# 2) Generate timeconst.h
 52
 53timeconst-file := include/generated/timeconst.h
 54
 55targets += $(timeconst-file)
 56
 57quiet_cmd_gentimeconst = GEN     $@
 58define cmd_gentimeconst
 59	(echo $(CONFIG_HZ) | bc -q $< ) > $@
 60endef
 61define filechk_gentimeconst
 62	(echo $(CONFIG_HZ) | bc -q $< )
 63endef
 64
 65$(obj)/$(timeconst-file): kernel/time/timeconst.bc FORCE
 66	$(call filechk,gentimeconst)
 67
 68#####
 69# 3) Generate asm-offsets.h
 70#
 71
 72offsets-file := include/generated/asm-offsets.h
 73
 74always  += $(offsets-file)
 75targets += arch/$(SRCARCH)/kernel/asm-offsets.s
 76
 77# We use internal kbuild rules to avoid the "is up to date" message from make
 78arch/$(SRCARCH)/kernel/asm-offsets.s: arch/$(SRCARCH)/kernel/asm-offsets.c \
 79                                      $(obj)/$(timeconst-file) $(obj)/$(bounds-file) FORCE
 80	$(Q)mkdir -p $(dir $@)
 81	$(call if_changed_dep,cc_s_c)
 82
 83$(obj)/$(offsets-file): arch/$(SRCARCH)/kernel/asm-offsets.s FORCE
 84	$(call filechk,offsets,__ASM_OFFSETS_H__)
 85
 86#####
 87# 4) Check for missing system calls
 88#
 89
 90always += missing-syscalls
 91targets += missing-syscalls
 92
 93quiet_cmd_syscalls = CALL    $<
 94      cmd_syscalls = $(CONFIG_SHELL) $< $(CC) $(c_flags) $(missing_syscalls_flags)
 95
 96missing-syscalls: scripts/checksyscalls.sh $(offsets-file) FORCE
 
 97	$(call cmd,syscalls)
 98
 99# Keep these three files during make clean
100no-clean-files := $(bounds-file) $(offsets-file) $(timeconst-file)